%ifarch %{arm} aarch64
%define build_docs 0
%else
%define build_docs 0
%endif

%define snapshot 0
%define pre rc

%define qtmajor 5
%define qtminor 15
%define qtsubminor 6

%define rel 1

%define major_private 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqtwaylandclient %mklibname qt5waylandclient %qtmajor
%define libqtwaylandcompositor %mklibname qt5waylandcompositor %qtmajor
%define libqtwayland_d %mklibname qt5waylandclient -d

%if %snapshot
%define qttarballdir qtwayland-everywhere-src-%{qtversion}-%pre
%else
%define qttarballdir qtwayland-everywhere-opensource-src-%{qtversion}
%endif

Name:           qtwayland5
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} Wayland platform support and QtCompositor module
Group:          Development/Libraries
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
# Upstream patches
# https://community.kde.org/Qt5PatchCollection
Patch0001:	0001-Client-Announce-an-output-after-receiving-more-compl.patch
Patch0002:      0002-Fix-issue-with-repeated-window-size-changes.patch
Patch0003:      0003-Client-Connect-drags-being-accepted-to-updating-the-.patch
Patch0004:      0004-Client-Disconnect-registry-listener-on-destruction.patch
Patch0005:      0005-Client-Set-XdgShell-size-hints-before-the-first-comm.patch
Patch0006:      0006-Fix-build.patch
Patch0007:      0007-Fix-remove-listener.patch
Patch0008:      0008-Hook-up-queryKeyboardModifers.patch
Patch0009:      0009-Correctly-detect-if-image-format-is-supported-by-QIm.patch
Patch0010:      0010-Wayland-client-Fix-crash-when-windows-are-shown-hidd.patch
Patch0011:      0011-Client-Don-t-always-recreate-frame-callbacks.patch
Patch0012:      0012-Client-Always-destroy-frame-callback-in-the-actual-c.patch
Patch0013:      0013-Fix-the-logic-for-decoding-modifiers-map-in-Wayland-.patch
Patch0014:      0014-Wayland-client-use-wl_keyboard-to-determine-active-s.patch
Patch0015:      0015-Client-do-not-empty-clipboard-when-a-new-popup-windo.patch
Patch0016:      0016-Set-preedit-cursor-when-cursor-equals-to-0.patch
Patch0017:      0017-Client-Implement-DataDeviceV3.patch
Patch0018:      0018-Client-Delay-deletion-of-QDrag-object-until-after-we.patch
Patch0019:      0019-Client-Avoid-processing-of-events-when-showing-windo.patch
Patch0020:      0020-Handle-registry_global-out-of-constructor.patch
Patch0021:      0021-Connect-flushRequest-after-forceRoundTrip.patch
Patch0022:      0022-Move-the-wayland-socket-polling-to-a-separate-event-.patch
Patch0023:      0023-Do-not-create-decorations-when-the-shellSurface-is-n.patch
Patch0024:      0024-Fix-crash-if-no-input-method-module-could-be-loaded.patch
Patch0025:      0025-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0026:      0026-Cursor-position-0-should-still-show-the-cursor.patch
Patch0027:      0027-Update-the-preedit-styling-mapping.patch
Patch0028:      0028-client-Simplify-round-trip-behavior.patch
Patch0029:      0029-Client-Fix-opaque-region-setter.patch
Patch0030:      0030-Use-proper-dependencies-in-compile-tests.patch
Patch0031:      0031-client-update-button-state-and-etc-in-pointer_leave.patch
Patch0032:      0032-Revert-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0033:      0033-Fix-race-condition-on-mWaitingForUpdateDelivery.patch
Patch0034:      0034-use-poll-2-when-reading-from-clipboard.patch
Patch0035:      0035-Reduce-memory-leakage.patch
Patch0036:      0036-Fix-build-with-libcxx-missing-array-include.patch
Patch0037:      0037-Only-close-popup-in-the-the-hierchary.patch
Patch0038:      0038-Build-fixes-for-GCC-11.patch
Patch0039:      0039-Check-pointer-for-null-before-use-in-ASSERT.patch
Patch0040:      0040-Use-wl_surface.damage_buffer-on-the-client-side.patch
Patch0041:      0041-Client-clear-focus-on-touch-cancel.patch
Patch0042:      0042-Guard-mResizeDirty-by-the-correctMutex.patch
Patch0043:      0043-client-Synthesize-enter-leave-event-for-popup-in-xdg.patch
Patch0044:      0044-Fix-compile-tests.patch

BuildRequires:  qtbase5-devel >= %version
BuildRequires:  pkgconfig(Qt5Quick) >= %version
BuildRequires:  qt5platformsupport-devel
BuildRequires:  qt5vulkansupport-devel

BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5DBus)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5OpenGL)

BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(wayland-scanner)
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(wayland-client)
BuildRequires:  pkgconfig(wayland-cursor)
BuildRequires:  pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(xcomposite)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(fontconfig)

BuildRequires:  re2c >= 0.11.3

BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(libpci)
BuildRequires:  pkgconfig(nss)

# needed for QtServiceSupport/private/qgenericunixservices_p.h
BuildRequires:  %{_lib}qt5servicesupport-static-devel
# needed for QtFontDatabaseSupport/private/qgenericunixfontdatabase_p.h
BuildRequires:  %{_lib}qt5fontdatabasesupport-static-devel
BuildRequires:  %{_lib}qt5themesupport-static-devel
BuildRequires:  %{_lib}qt5eventdispatchersupport-static-devel
BuildRequires:  %{_lib}qt5eglsupport-static-devel
BuildRequires:  %{_lib}qt5glxsupport-static-devel
BuildRequires:  %{_lib}qt5xkbcommonsupport-static-devel
BuildRequires:  %{_lib}qt5accessibilitysupport-static-devel
BuildRequires:  %{_lib}qt5linuxaccessibilitysupport-static-devel

#Branch Patchs

#Trunk Patchs

#Patch from Mageia

%description
Qt%{qtmajor} Wayland platform support and QtCompositor module.

%files
%{_qt5_bindir}/qtwaylandscanner
%{_qt5_qml}/QtWayland/
%{_qt5_plugindir}/platforms/*.so
%{_qt5_plugindir}/wayland-decoration-client/
%{_qt5_plugindir}/wayland-graphics-integration-client/
%{_qt5_plugindir}/wayland-graphics-integration-server/
%{_qt5_plugindir}/wayland-shell-integration/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtWayland%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools5
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools5-assistant
Recommends:     qttools5-assistant

%description doc
Documentation for APIs and tools in QtWayland%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt5_docdir}/qtwayland*.qch
%{_qt5_docdir}/qtwayland*/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandclient}
Summary:        Qt%{qtmajor} WaylandClient Component Library
Group:          System/Libraries
# Fix naming glitch in cauldron (mga6)
Obsoletes:      %{_lib}gqtwaylandclient5 < 5.6.0-2

%description -n %{libqtwaylandclient}
Qt%{qtmajor} WaylandClient Component Library.

%files -n %{libqtwaylandclient}
%{_qt5_libdir}/libQt5WaylandClient.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandcompositor}
Summary:        Qt%{qtmajor} WaylandCompositor Component Library
Group:          System/Libraries

%description -n %{libqtwaylandcompositor}
Qt%{qtmajor} WaylandCompositor Component Library.

%files -n %{libqtwaylandcompositor}
%{_qt5_libdir}/libQt5WaylandCompositor.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n     %{libqtwayland_d}
Summary:        Devel files needed to build apps based on QtWayland
Group:          Development/Libraries
Requires:       %{libqtwaylandclient} = %version
Requires:       %{libqtwaylandcompositor} = %version
Requires:       %{_lib}qt5linuxaccessibilitysupport-static-devel
Provides:       libqtwayland5-devel = %version
Provides:       libqt5wayland-devel = %version
Provides:       qtwayland5-devel = %version
Provides:       qt5wayland-devel = %version

Provides:       libqtwayland-private-devel = %version
Provides:       libqtwayland5-private-devel = %version
Provides:       libqt5wayland-private-devel = %version
Provides:       qtwayland-private-devel = %version
Provides:       qt5wayland-private-devel = %version

%description -n %{libqtwayland_d}
Devel files needed to build apps based on Qt Wayland.

%files -n %{libqtwayland_d}
%{_qt5_libdir}/libQt5WaylandClient.so
%{_qt5_libdir}/libQt5WaylandCompositor.so
%{_qt5_libdir}/libQt5WaylandClient.prl
%{_qt5_libdir}/libQt5WaylandCompositor.prl
%{_qt5_libdir}/pkgconfig/Qt5WaylandClient.pc
%{_qt5_libdir}/pkgconfig/Qt5WaylandCompositor.pc
%{_qt5_includedir}/QtWaylandClient/
%{_qt5_includedir}/QtWaylandCompositor/
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandclient.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor.pri
%{_qt5_libdir}/cmake/Qt5WaylandClient/
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/
%{_qt5_libdir}/cmake/Qt5Gui/*
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandclient_private.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor_private.pri
%{_qt5_examplesdir}/wayland/

#------------------------------------------------------------------------------

%prep
%setup -q -n qtwayland-everywhere-src-%{qtversion}
%apply_patches

%build
%qmake_qt5

RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; make -j $RPM_BUILD_NCPUS

%if %{build_docs}
%__make docs
%endif

%install
%make_install INSTALL_ROOT=%{buildroot}

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete

# Temporary workaround until an upstream fix
sed -i 's| Qt5LinuxAccessibilitySupport||' %{buildroot}%{_qt5_libdir}/pkgconfig/Qt5WaylandClient.pc
sed -i 's|"Qt5::LinuxAccessibilitySupport;|"|' %{buildroot}%{_qt5_libdir}/cmake/Qt5WaylandClient/Qt5WaylandClientConfig.cmake
sed -i 's|"LinuxAccessibilitySupport;|"|' %{buildroot}%{_qt5_libdir}/cmake/Qt5WaylandClient/Qt5WaylandClientConfig.cmake


%changelog
* Sun Sep 18 2022 tex - 5.15.6-1pclos2022
- new version